import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Chunin here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Chunin extends Enemies
{
    private GreenfootImage nin1;
    private GreenfootImage nin2;
    private GreenfootImage nin3;
    private static final int MOVE_AMOUNT=5;
    private boolean aband;
    private boolean lband;
    private boolean mband;

    /**
     * Act - do whatever the Chunin wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        movement();
        attack();
        move();
        intersectPlayer();
    }    

    public void attack()
    {
        if(getY()-getPlayer().getY()<=50)
            attackKatana();
    }

    public Chunin(boolean left)
    {
        nin1=this.getImage();
        nin2=new GreenfootImage("n4_3.png");
        nin3=new GreenfootImage("n4_2.png");
        if(left)
        {
            nin1.mirrorHorizontally();
            nin2.mirrorHorizontally();
            nin3.mirrorHorizontally();
        }
        this.setImage(nin1);
        aband=true;
        lband=left;
        mband=true;
    }

    public void attackKatana()
    {
        if(aband)
        {
            Katana katana;
            katana=new Katana();
            getWorld().addObject(katana,this.getX()+10,this.getY()-45);
            Greenfoot.delay(2);
            this.setImage(nin2);
            getWorld().moveCamera(MOVE_AMOUNT);
            intersectKatana();
            Greenfoot.delay(2);
            this.setImage(nin3);
            getWorld().moveCamera(MOVE_AMOUNT);
            intersectKatana();
            Greenfoot.delay(2);
            this.setImage(nin1);
            getWorld().moveCamera(MOVE_AMOUNT);    
            intersectKatana();
            deleteKatana();        
            aband=false;
        }
    }

    public void intersectKatana()
    {
        Actor aux;
        List kList=getWorld().getObjects(Katana.class);
        Iterator <Actor> it;
        if(!kList.isEmpty())
        {
            it=kList.iterator();
            aux=it.next();
            ((Katana)aux).intersectingNinjas();
        }
    }

    public void deleteKatana()
    {
        Actor aux;
        List kList=getWorld().getObjects(Katana.class);
        Iterator <Actor> it;
        if(!kList.isEmpty())
        {
            it=kList.iterator();
            aux=it.next();
            getWorld().removeObject(aux);
        }
    }

    public void movement()
    {
        if(mband)
        {
            if(getY()-getPlayer().getY()-50<=100)
            {
                if(lband)
                {
                    if(getX()>=116)
                        setLocation(getX()-10,getY());
                    else
                    {
                        nin1.mirrorHorizontally();
                        nin2.mirrorHorizontally();
                        nin3.mirrorHorizontally();
                        this.setImage(nin1);
                        mband=false;
                    }
                }
                else
                {
                    if(getX()<=684)
                        setLocation(getX()+10,getY());
                    else
                    {
                        nin1.mirrorHorizontally();
                        nin2.mirrorHorizontally();
                        nin3.mirrorHorizontally();
                        this.setImage(nin1);
                        mband=false;
                    }
                }
            }
        }
    }
}
