import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Ninja
{
    private static final int MOVE_AMOUNT=5;
    private int life;//Variable of the lifes
    private int stars;//Variable of the stars 
    private int score;//Variable of the score
    private boolean sband;//Band for validate the attack of the stars
    private boolean rband;//Band for validate right movement
    private boolean lband;//Band for validate left movement
    private GreenfootImage nin1;//Image 1 of the ninja
    private GreenfootImage nin2;//Image 2 of the ninja
    private GreenfootImage nin3;//Image 3 of the ninja
    private Actor aux;//Auxiliar with the deleted

    /**
     * Constructor for Player Class
     */
    public Player()
    {
        life=5;
        stars=10;
        score=0;
        sband=rband=lband=false;
        nin1=this.getImage();
        nin2=new GreenfootImage("ninja_2.png");
        nin3=new GreenfootImage("ninja_3.png");
    }
    
   

    /**
     * Act - do whatever the Player to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        Greenfoot.delay(2);
        getWorld().moveCamera(MOVE_AMOUNT);
        getWorld().setCameraDirection(90);
        attack();
        move();
        oneLifeLess();
        eat();
        getStar();
        if(this.getGlobalY()>2300)
        {
            this.returnCamera();
            ((Stage)getWorld()).changeLevel();
        }
        if(life<=0)
        {
          this.returnCamera();
          this.lose();
        }
    }    

    public void attack()
    {
        attackStars();
        attackKatana();
    }

    public void attackStars()
    {
        if(!sband&&stars>0)
        {
            if(Greenfoot.isKeyDown("enter"))
            {
                Stars star;
                star=new Stars(10);
                getWorld().addObject(star,this.getX()+10,this.getY()+45);
                sband=true;
                stars=stars-1;
                decrements(stars);
            }
        }
    }

    public void decrements(int Scr)
    {
        Stage world;
        world=(Stage)super.getWorld();
        Counter stars=world.getStars();
        stars.value(Scr);
    }
    
    public void attackKatana()
    {
        if(Greenfoot.isKeyDown("space"))
        {
            Katana katana;
            katana=new Katana();
            getWorld().addObject(katana,this.getX()+10,this.getY()+45);
            Greenfoot.delay(2);
            this.setImage(nin2);
            getWorld().moveCamera(MOVE_AMOUNT);
            intersectKatana();
            Greenfoot.delay(2);
            this.setImage(nin3);
            getWorld().moveCamera(MOVE_AMOUNT);
            intersectKatana();
            Greenfoot.delay(2);
            this.setImage(nin1);
            getWorld().moveCamera(MOVE_AMOUNT);    
            intersectKatana();
            deleteKatana();
        }
    }

    public void intersectKatana()
    {
        List kList=getWorld().getObjects(Katana.class);
        Iterator <Actor> it;
        if(!kList.isEmpty())
        {
            it=kList.iterator();
            aux=it.next();
            ((Katana)aux).intersectingNinjas();
        }
    }

    public void deleteKatana()
    {
        List kList=getWorld().getObjects(Katana.class);
        Iterator <Actor> it;
        if(!kList.isEmpty())
        {
            it=kList.iterator();
            aux=it.next();
            getWorld().removeObject(aux);
        }
    }

    public void move()
    {
        moveY();
        moveX();
    }

    public void moveY()
    {
        if(Greenfoot.isKeyDown("down"))
            if(getY()<=572)
                setLocation(getX(),getY()+5);
        if(Greenfoot.isKeyDown("up"))
            if(getY()>=28)
                setLocation(getX(),getY()-5);
    }

    public void moveX()
    {
        if(Greenfoot.isKeyDown("right"))
        { 
            if(!lband&&getX()==115)
                rband=true;
        }

        if(Greenfoot.isKeyDown("left"))
        {   
            if(!rband&&getX()==685)
                lband=true;
        }

        if(rband)
        {
            if(getX()<=684)
                setLocation(getX()+10,getY());
            else
            {
                nin1.mirrorHorizontally();
                nin2.mirrorHorizontally();
                nin3.mirrorHorizontally();
                this.setImage(nin1);
                rband=false;
            }
        }

        if(lband)
        {
            if(getX()>=116)
                setLocation(getX()-10,getY());
            else
            {
                nin1.mirrorHorizontally();
                nin2.mirrorHorizontally();
                nin3.mirrorHorizontally();
                this.setImage(nin1);
                lband=false;
            }
        }        
    }

    public void getStar()
    {
        List sList=getWorld().getObjects(Stars.class);
        if(sList.isEmpty())
            sband=false;
    }

    public void oneLifeLess()
    {
        oLLEnemies();
        oLLObstacles();
    }

    public void oLLEnemies()
    {
        aux=getOneIntersectingObject(Enemies.class);
        if(aux!=null)
        {
            life-=1;
        }
    }

    public void oLLObstacles()
    {
        aux=getOneIntersectingObject(Obstacles.class);
        if(aux!=null)
        {
            life-=1;
        }
    }

    public void oLLArms()
    {
        aux=getOneIntersectingObject(Arms.class);
        if(aux!=null)
        {
            life-=1;
        }
    }

    public void eat()
    {
        eatStrawberry();
        eatLive();
        eatStar();
    }

    public void eatStrawberry()
    {
        aux=getOneIntersectingObject(Strawberry.class);
        if(aux!=null)
        {
            score+=5;
        }
    }

    public void eatLive()
    {
        aux=getOneIntersectingObject(Live.class);
        if(aux!=null)
        {
            life+=1;
        }
    }

    public void eatStar()
    {
        aux=getOneIntersectingObject(Star.class);
        if(aux!=null)
        {
            stars+=3;
        }
    }

    public int returnScore()
    {
        return score;
    }

    public int returnLifes()
    {
        return life;
    }

    public int returnStars()
    {
        return stars;
    }
    
    public int retunX()
    {
        return this.getGlobalX();
    }
    
    public int returnY()
    {
        return this.getGlobalY();
    }
    
    public void lose()
    {
        getWorld().setBackground("perdiste.png");
        Greenfoot.delay(50);
        ((Stage)getWorld()).letLose();
    }
    
    public void returnCamera()
    {
        ((ScrollWorld)getWorld()).setCameraLocation(400,300);
    }
    
    public void catchLife(int aValue)
    {
        life=aValue;
    }
    
    public void catchStar(int aValue)
    {
        stars=aValue;
    }
    
    public void catchScore(int aValue)
    {
        score=aValue;
    }
    
}
