import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*; // (List, Iterator)

/**
 * Write a description of class Stage here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Stage extends ScrollWorld
{
    private int level;//Variable of the Level
    private GreenfootImage backGround;
    private Counter score;
    private Counter life;
    private Counter stars;
    private Counter cLevel;
    private Signboard mScore;
    private Signboard mLife;
    private Signboard mStars;
    private Signboard mLevel;

    /**
     * Constructor for objects of class Stage.
     * 
     */
    public Stage()
    {    
        super(800,600,1,800,5000); // Create a new ScrollWorld with 800x600 cells with a cell size of 1x1 pixels and limits 800x3000.
        level=0;//Initializes the level to 0
        prepare();//Prepare the game to play
    }

    /**
     * Prepares the Stage for the cover
     */
    public void prepare()
    {
        setBackground("portada.jpg");
        bPlay play=new bPlay();
        addObject(play,454,400);
        bRecords records=new bRecords();
        addObject(records,200,300);
        bHelp help=new bHelp();
        addObject(help,700,300);
        bCredits credits=new bCredits();
        addObject(credits,200,500);
    }

    /**
     * 
     */
    public void preparelevel1()
    {
        level=1;
        score=new Counter();
        addObject(score,540,20);
        mScore=new Signboard("Score");
        addObject(mScore,498,20);
        life=new Counter();
        life.value(5);
        addObject(life,120,20);
        mLife=new Signboard("Life");
        addObject(mLife,90,20);
        addCameraFollower(new Player(),getWidth()/2-285,getHeight()/2-270);
        stars=new Counter();
        stars.value(10);
        addObject(stars,300,20);
        mStars=new Signboard("Stars");
        addObject(mStars,250,20);
        cLevel=new Counter();
        cLevel.value(1);
        addObject(cLevel,650,20);
        mLevel=new Signboard("Level");
        addObject(mLevel,600,20);
        
        Star sta=new Star();
        addObject(sta,116,1823);
        Star sta1=new Star();
        addObject(sta1,116,2154);
        
        Genin genin = new Genin(true);
        addObject(genin, 684, 560);
        Genin genin1 = new Genin(true);
        addObject(genin1, 684, 1500);
        Genin genin2 = new Genin(false);
        addObject(genin2, 116, 1060);
        Genin genin3 = new Genin(false);
        addObject(genin3, 116, 1500);

        Strawberry pun = new Strawberry();
        addObject(pun,116,20);
        Strawberry pun1 = new Strawberry();
        addObject(pun1,116,900);
        Strawberry pun3 = new Strawberry();
        addObject(pun3,116,1500);
        Strawberry pun2 = new Strawberry();

        Live vid = new Live();
        addObject(vid,80,525);
        Live vid2 = new Live();
        addObject(vid2,684,1620);

        addObject(pun2,684,1000);
        Strawberry pun4 = new Strawberry();
        addObject(pun4,684,2100);
        Strawberry pun5 = new Strawberry();
        addObject(pun5,684,1580);

        Barrera barr=new Barrera();
        addObject(barr,116,540);
        Barrera barr4=new Barrera();
        addObject(barr4,684,1000);
        Barrera barr5=new Barrera();
        addObject(barr5,684,1500);
        Barrera barr6=new Barrera();
        addObject(barr6,684,2000);
        Barrera barr1=new Barrera();
        addObject(barr1,116,2500);
        Barrera barr2=new Barrera();
        addObject(barr2,116,1200);
        Barrera barr3=new Barrera();
        addObject(barr3,116,1500);
    }

    public void prepare3()
    {

        Barrera barr1=new Barrera();
        addObject(barr1,116,500);
        Barrera barr2=new Barrera();
        addObject(barr2,684,600);
        Barrera barr3=new Barrera();
        addObject(barr3,116,1000);
        Barrera barr4=new Barrera();
        addObject(barr4,684,1200);
        Barrera barr5=new Barrera();
        addObject(barr5,116,1500);
        Barrera barr6=new Barrera();
        addObject(barr6,684,2000);
        Barrera barr7=new Barrera();
        addObject(barr7,116,2500);

        Strawberry pun = new Strawberry();
        addObject(pun,116,20);
        Strawberry pun1 = new Strawberry();
        addObject(pun1,116,900);
        Strawberry pun3 = new Strawberry();
        addObject(pun3,116,1700);
        Strawberry pun2 = new Strawberry();
        addObject(pun2,684,1200);
        Strawberry pun4 = new Strawberry();
        addObject(pun4,684,2100);
        Strawberry pun5 = new Strawberry();
        addObject(pun5,684,1580);

        Live vid = new Live();
        addObject(vid,116,525);
        Live vid2 = new Live();
        addObject(vid2,684,1620);
        Live vid3 = new Live();
        addObject(vid3,116,275);

        Chunin chunin=new Chunin(true);
        addObject(chunin,684,700);

        Chunin chunin4=new Chunin(false);
        addObject(chunin4,116, 1500);

        Genin genin = new Genin(true);
        addObject(genin, 684, 560);
        Genin genin1 = new Genin(true);
        addObject(genin1, 684, 1500);
        Genin genin4 = new Genin(true);
        addObject(genin4, 684, 2060);

        Genin genin5 = new Genin(false);
        addObject(genin5, 116, 900);
        Genin genin6 = new Genin(false);
        addObject(genin6, 116, 1900);
        Genin genin7 = new Genin(false);
        addObject(genin7, 116, 2235);

        tend_1 teni = new tend_1();
        addObject(teni,650,2156);
        
        Star sta=new Star();
        addObject(sta,116,1823);
        Star sta1=new Star();
        addObject(sta1,684,2154);
    }

    public void prepare4()
    {

        Barrera barr1=new Barrera();
        addObject(barr1,116,700);
        Barrera barr2=new Barrera();
        addObject(barr2,684,400);
        Barrera barr3=new Barrera();
        addObject(barr3,116,1200);
        Barrera barr4=new Barrera();
        addObject(barr4,684,900);
        Barrera barr5=new Barrera();
        addObject(barr5,116,1300);
        Barrera barr7=new Barrera();
        addObject(barr7,116,2100);
        Barrera barr8=new Barrera();
        addObject(barr8,684,2300);
        Barrera barr9=new Barrera();
        addObject(barr9,116,2500);

        Strawberry pun = new Strawberry();
        addObject(pun,116,500);
        Strawberry pun1 = new Strawberry();
        addObject(pun1,116,1952);
        Strawberry pun3 = new Strawberry();
        addObject(pun3,116,1236);
        Strawberry pun2 = new Strawberry();
        addObject(pun2,684,1200);
        Strawberry pun4 = new Strawberry();
        addObject(pun4,684,2100);
        Strawberry pun5 = new Strawberry();
        addObject(pun5,684,1580);

        Live vid = new Live();
        addObject(vid,116,525);
        Live vid2 = new Live();
        addObject(vid2,684,1620);
        Live vid3 = new Live();
        addObject(vid3,116,275);

        Chunin chunin=new Chunin(true);
        addObject(chunin,684,700);
        Chunin chunin1=new Chunin(false);
        addObject(chunin1,116,1700);

        Genin genin5 = new Genin(false);
        addObject(genin5, 116, 900);
        Genin genin6 = new Genin(false);
        addObject(genin6, 116, 1900);
        Genin genin7 = new Genin(false);
        addObject(genin7, 116, 2000);

        Genin genin = new Genin(true);
        addObject(genin, 684, 560);
        Genin genin1 = new Genin(true);
        addObject(genin1, 684, 1500);
        Genin genin2 = new Genin(true);
        addObject(genin2, 684, 1060);
      
        
        Jounin ninja2 = new Jounin(false);
        addObject(ninja2,684,2035);
     
        tend_1 teni = new tend_1();
        addObject(teni,180,1856);
        
        Star sta=new Star();
        addObject(sta,116,865);
        Star sta1=new Star();
        addObject(sta1,684,1654);
    }
    

    public void prepare5()
    {

        Barrera barr1=new Barrera();
        addObject(barr1,116,700);
        Barrera barr2=new Barrera();
        addObject(barr2,684,400);
        Barrera barr3=new Barrera();
        addObject(barr3,116,1200);
        Barrera barr4=new Barrera();
        addObject(barr4,684,900);
        Barrera barr5=new Barrera();
        addObject(barr5,116,1300);
        Barrera barr6=new Barrera();
        addObject(barr6,684,1700);
        Barrera barr7=new Barrera();
        addObject(barr7,116,2100);
        Barrera barr8=new Barrera();
        addObject(barr8,684,2300);
        Barrera barr9=new Barrera();
        addObject(barr9,116,2500);

        Strawberry pun = new Strawberry();
        addObject(pun,116,500);
        Strawberry pun1 = new Strawberry();
        addObject(pun1,116,1952);
        Strawberry pun3 = new Strawberry();
        addObject(pun3,116,1236);
        Strawberry pun2 = new Strawberry();
        addObject(pun2,684,1200);
        Strawberry pun4 = new Strawberry();
        addObject(pun4,684,2100);
        Strawberry pun5 = new Strawberry();
        addObject(pun5,684,1580);

        Live vid = new Live();
        addObject(vid,116,525);
        Live vid2 = new Live();
        addObject(vid2,684,1620);
        Live vid3 = new Live();
        addObject(vid3,116,275);


        Chunin chunin3=new Chunin(false);
        addObject(chunin3,116, 1000);
        Chunin chunin5=new Chunin(false);
        addObject(chunin5,116, 2000);
        Genin genin7 = new Genin(true);
        addObject(genin7, 684, 2500);

        Genin genin = new Genin(true);
        addObject(genin, 684, 560);
        Genin genin1 = new Genin(true);
        addObject(genin1, 684, 1500);
        Genin genin2 = new Genin(true);
        addObject(genin2, 684, 1060);
        Genin genin3 = new Genin(true);
        addObject(genin3, 684, 1560);
        Genin genin4 = new Genin(true);
        addObject(genin4, 684, 2060);

        Jounin ninja = new Jounin(true);
        addObject(ninja,116,800);

        tend_1 teni = new tend_1();
        addObject(teni,400,1325);
    }

    public void prepare6()
    {

        Barrera barr1=new Barrera();
        addObject(barr1,116,300);
        Barrera barr2=new Barrera();
        addObject(barr2,684,400);
        Barrera barr3=new Barrera();
        addObject(barr3,116,800);
        Barrera barr4=new Barrera();
        addObject(barr4,684,1600);
        Barrera barr5=new Barrera();
        addObject(barr5,116,1300);
        Barrera barr6=new Barrera();
        addObject(barr6,684,1700);
        Barrera barr7=new Barrera();
        addObject(barr7,116,2100);
        Barrera barr8=new Barrera();
        addObject(barr8,684,2300);
        Barrera barr9=new Barrera();
        addObject(barr9,116,2500);

        Strawberry pun = new  Strawberry();
        addObject(pun,116,500);
        Strawberry pun1 = new  Strawberry();
        addObject(pun1,116,1952);
        Strawberry pun3 = new  Strawberry();
        addObject(pun3,116,1236);
        Strawberry pun2 = new  Strawberry();
        addObject(pun2,684,1200);
        Strawberry pun4 = new  Strawberry();
        addObject(pun4,684,2100);
        Strawberry pun5 = new  Strawberry();
        addObject(pun5,684,1580);

        Live vid = new Live();
        addObject(vid,116,525);
        Live vid2 = new Live();
        addObject(vid2,684,1620);
        Live vid3 = new Live();
        addObject(vid3,116,275);

        Chunin chunin=new Chunin(true);
        addObject(chunin,684,700);
        Chunin chunin1=new Chunin(true);
        addObject(chunin1,684,1700);
        Chunin chunin2=new Chunin(true);
        addObject(chunin2,684,2500);


        Genin genin5 = new Genin(false);
        addObject(genin5, 116, 900);
        Genin genin6 = new Genin(false);
        addObject(genin6, 116, 1900);
        Genin genin7 = new Genin(false);
        addObject(genin7, 116, 2000);

        Genin genin = new Genin(true);
        addObject(genin, 684, 560);
        Genin genin3 = new Genin(true);
        addObject(genin3, 684, 1560);
        Genin genin4 = new Genin(true);
        addObject(genin4, 684, 2060);

        Jounin ninja2 = new Jounin(false);
        addObject(ninja2,684,2035);
        Jounin ninja3 = new Jounin(false);
        addObject(ninja3,684,2102);

        tend_izq teni = new tend_izq();
        addObject(teni,180,1325);
        tend_izq tend = new tend_izq();
        addObject(tend,600,1325);
        tend_izq teni1 = new tend_izq();
        addObject(teni1,180,1759);
        tend_izq tend1 = new tend_izq();
        addObject(tend1,600,1759);
        tend_izq teni2= new tend_izq();
        addObject(teni2,180,2156);
        tend_izq tend2 = new tend_izq();
        addObject(tend2,600,2156);
    }

    /**
     * 
     */
    public void outStage()
    {
        List elist=getObjects(ScrollActor.class);
        Iterator <Actor> it;
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            if(aux.getY()<=0)
            {
                removeObject((ScrollActor)aux);
            }
        }
        elist=getObjects(Arms.class);
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            if(aux.getY()>=600)    
                removeObject(aux);
            else if(aux.getY()<=0)
                removeObject(aux);
        }      

    }

    public void act()
    {
        outStage();

    }

    public Counter getScore()
    {
        return score;
    }

    public Counter getLife()
    {
        return life;
    }

    public Counter getStars()
    {
        return stars;
    }

    public void changeLevel()
    {
        level++;
        deleteScrollActors();
        cLevel.value(level);
        switch(level)
        {
            case 2:
            prepare3();
            break;

            case 3:
            prepare4();
            break;

            case 4:
            prepare5();
            break;

            case 5:
            prepare6();
            break;

            case 6:
            Greenfoot.stop();
            Signboard letrero= new Signboard("You Win!");
            addObject(letrero,getWidth()/2,getHeight()/2);
        }
    }

    public void letLose()
    {
        Signboard lost= new Signboard("You Lose!");
        addObject(lost,getWidth()/2,getHeight()/2);
        deleteScrollActors();
        deletePlayer();
        deleteActors();
        prepare();
    }

    public void deletePlayer()
    {
        List elist=getObjects(Player.class);
        Iterator <Actor> it;
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            removeObject((ScrollActor)aux);
        }

    }

    public void deleteScrollActors()
    {
        List elist=getObjects(Aliment.class);
        Iterator <Actor> it;
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            removeObject((ScrollActor)aux);
        }
        elist=getObjects(Obstacles.class);
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            removeObject((ScrollActor)aux);
        }
        elist=getObjects(Enemies.class);
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            removeObject((ScrollActor)aux);
        }

    }

    public void deleteActors()
    {
        List elist=getObjects(Actor.class);
        Iterator <Actor> it;
        it=elist.iterator();
        while(it.hasNext())
        {
            Actor aux=it.next();
            removeObject(aux);
        }
    }

    public void GameRecords()
    {

        this.setBackground("portada.jpg");
        java.util.List records=UserInfo.getTop(7);
        RecordUser usuario;
        UserInfo info;
        if(records!=null)
        {
            for(int i=0; i<records.size(); i++)
            {
                info=(UserInfo)records.get(i);
                usuario=new RecordUser((i+1)+".- "+info.getUserName(),info.getScore(),info.getUserImage());
                usuario.addToWorld(100+50*i,this);
            }

            Signboard let;
            if(UserInfo.getMyInfo().getRank()>0)
            {
                let=new Signboard("Your Position:"+UserInfo.getMyInfo().getRank());
            }
            else
            {
                let=new Signboard("You aren't in the Records List");
            }
            this.addObject(let,20+(let.getImage().getWidth()/2),480);
        }
        else
        {
            Signboard letr=new Signboard("Whitout Scores...");
            this.addObject(letr,350,250);
        }

    }
}

